<?php
# ---------------------------------------------------------------------------------

/**
* @version v 2.0 for Joomla! 1.5.x
* @author: Gero Zahn, gero@gerozahn.de, http://www.gerozahn.de/bot_gzFlashEmbed/
*   ... inspired by mywFlashbot Marc Hinse www.madeyourweb.com
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.*/

/*

	NOTE:

		This is a legacy implementation of the gzflashembed mambot - i.e.
		not much more than the original mambot tuned up to Joomla! 1.5.

		As this "registerEvent(...)" implementation will become deprecated
		sooner or later, there will of course be a true, more efficient
		"class plgContentGzFlashEmbed extends JPlugin" implementation.

		But sorry - not today ...

*/

# ---------------------------------------------------------------------------------

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onBeforeDisplayContent', 'plggzflashembed_legacy' );

# ---------------------------------------------------------------------------------

# === The main routine to search for the {flashembet}...{/flashembed} pseudotags
function plggzflashembed_legacy( &$row, &$params, $page=0 ) {
global $textembed,$swftextcss,$embednum;

	// define the regular expression to find the {flashembet}...{/flashembed} pseudotags
	$regex = "#{flashembed}(.*?){/flashembed}#s";

	// Get the plugin and the plugin parameters
	$plugin =& JPluginHelper::getPlugin('content', 'gzflashembed_legacy');
	$pluginParams = new JParameter( $plugin->params );

	$textembed = $pluginParams->get("textembed");
	$swftextcss = $pluginParams->get("swftextcss");

	$embednum=0;

	// perform the actual replacement via the callback
	$row->text = preg_replace_callback( $regex, 'botgzflashembed_replacer', $row->text );

#	return true;

}

# ---------------------------------------------------------------------------------

# === expand the {flashembet}...{/flashembed} pseudotags
function botgzflashembed_replacer ( &$matches ) {

	$result=""; # Sanity - no result

	$pars=array( # Default values (to be overwritten if part of param string
					"swf" => null, # path to flash undefined - sanity setting
					"width" => null, # width undefinied - useful, but not necessary
					"height" => null, # height undefined - useful, but not necessary
					"title" => null, # title undefined - HTML title unnecessary
					"version" => "6,0,0,0", # Flash Player 6,0,0,0 required
					"wmode" => "opaque", # Window mode opaque (DHTML objects can but put over this)
					"play" => "true", # autoplay default on
					"loop" => "true", # loop default on
					"quality" => "high", # quality default high
					"scale" => "showall", # scale default showfall (Flash default)
					"menu" => "false", # menu default hidden (no user control=)
					"align" => "middle", # HTML align default middle
					"salign" => "" # Flash align middle/middle
				);

	$rawpars=explode("|",$matches[1]); # What params may the user have given us?

	foreach($rawpars as $rawpar) { # Parse them all

		$curpar=explode("=",$rawpar); # Separate key name and parameter value

		if ($curpar[1]) { # is there a value behind the "="?

			$newkey=$curkey=strtolower($curpar[0]); # all key names are lower case
			$newpar=$curpar=urldecode($curpar[1]); # all param values are possibly urlencoded (eg. paths)

			switch ($curkey) { # key specific auto values

				case "w" : $newkey="width"; break; # w = width
				case "h" : $newkey="height"; break; # h = height
				case "t" : $newkey="title"; break; # t = title

				# ----------
				case "v" : { # v = version - usually x,0,0,0

					$newkey="version";

					if ( ( ((int)($curpar))>0 ) and (strlen("$curpar")<=2) ) { # just a number 1..99?
						$newpar="$curpar,0,0,0"; # OK - Flash version with subversions
					}

				} break;
				# ----------
				case "wm" : { # wm = wmode - w=window, o=opaque, t=transparent

					$newkey="wmode";

					switch (strtolower($curpar)) {
						case "w" : $newpar="window"; break;
						case "o" : $newpar="opaque"; break;
						case "t" : $newpar="transparent"; break;
					}

				} break;
				# ----------
				case "p" : { # p = play - 1=true, 0=false

					$newkey="play";

					switch (strtolower($curpar)) {
						case "1" : $newpar="true"; break;
						case "0" : $newpar="false"; break;
					}

				} break;
				# ----------
				case "l" : { # l = loop - 1=true, 0=false

					$newkey="loop";

					switch (strtolower($curpar)) {
						case "1" : $newpar="true"; break;
						case "0" : $newpar="false"; break;
					}

				} break;
				# ----------
				case "q" : { # q = quality - l=low, m=medium, h=high, b=best, al=autolow, ah=autohigh

					$newkey="quality";

					switch (strtolower($curpar)) {
						case "l" : $newpar="low"; break;
						case "m" : $newpar="medium"; break;
						case "h" : $newpar="high"; break;
						case "b" : $newpar="best"; break;
						case "al" : $newpar="autolow"; break;
						case "ah" : $newpar="autohigh"; break;
					}

				} break;
				# ----------
				case "s" : { # s = scale - sa=showall, nb=noborder, ef=exactfit, ns=noscale
					$newkey="scale";

					switch (strtolower($curpar)) {
						case "sa" : $newpar="showall"; break;
						case "nb" : $newpar="noborder"; break;
						case "ef" : $newpar="exactfit"; break;
						case "ns" : $newpar="noscale"; break;
					}

				} break;
				# ----------
				case "m" : { # m = menu - 1=true, 0=false

					$newkey="menu";

					switch (strtolower($curpar)) {
						case "1" : $newpar="true"; break;
						case "0" : $newpar="false"; break;
					}

				} break;
				# ----------
				case "a" : { # a = align - l=left, t=top, r=right, b=bottom, m=middle

					$newkey="align";

					switch (strtolower($curpar)) {
						case "m": $newpar="middle"; break;
						case "l": $newpar="left"; break;
						case "t": $newpar="top"; break;
						case "r": $newpar="right"; break;
						case "b": $newpar="bottom"; break;
					}

				} break;
				# ----------
				case "sa" : $newkey="salign"; break; # sa = salign - lt / t / rt // l / '' / r // lb / b / rb

			} # switch ($curkey)

			$pars[$newkey]=$newpar; # perhaps overwriting a default value

		} # if ($curpar[1])
	}

	if ( (!$pars["swf"]) or (!$pars["width"]) or (!$pars["height"]) ) { # At least give swf, width and height

		$result=<<<EOT
flashembed - you have to at least supply a Flash file name, height and width<br />
You gave: $matches[1]<br />
<br />
swf = Flash file name - if necessary urlencode this<br />
w = width - default undefined<br />
h = height - default undefined<br />
t = title - default undefined<br />
v = version - default 6,0,0,0<br />
wm = wmode - w=window, o=opaque, t=transparent - default opaque<br />
p = play - 1=true, 0=false - default true<br />
l = loop - 1=true, 0=false - default true<br />
q = quality - l=low, m=medium, h=high, b=best, al=autolow, ah=autohigh - default high<br />
s = scale - sa=showall, nb=noborder, ef=exactfit, ns=noscale - default showall<br />
m = menu - 1=true, 0=false - default false<br />
a = align - l=left, t=top, r=right, b=bottom, m=middle - default middle<br />
sa = salign - lt / t / rt | l / "" / r | lb / b / rb - default = ""=middle<br />
... You may also add additional parameters with yet unknown key names and parameter values.<br />
<br />
Example:<br />
{flashembed}swf=flashfilename.swf|w=100|h=100|v=7|p=0|wm=t{/flashembed}<br />
... for a 100x100 version 7,0,0,0 / autoplay=false / wmode=transparent embedding<br />

EOT;

	} else {

		$swf = $pars["swf"]; unset($pars["swf"]); # Which .swf file?

		if ( substr($swf, 0, 7)=="http://" ) { # Full remote URL?

			$fullpath=$swf; # OK -- this is it
			$fullabspath=null; # No absolut path for remote Flash

		} else { # Local path

			if ($swf{0}!="/") { $swf="/$swf"; } # Add leading "/" if not present

#			$fullpath=$mosConfig_live_site.$swf; # Add CMS' root path
#			$fullabspath=$mosConfig_absolute_path.$swf; # Add CMS' root path
			$fullpath=JURI::base().$swf; # Add CMS' root path
			$fullabspath=JPATH_SITE.$swf; # Add CMS' root path

		}

		$width = $pars["width"]; unset($pars["width"]);
		$height= $pars["height"]; unset($pars["height"]);
		$title = $pars["title"]; unset($pars["title"]);
		$version = $pars["version"]; unset($pars["version"]);
		$align = $pars["align"]; unset($pars["align"]);

		$vars1="";
		$vars2="";

		foreach($pars as $pkey => $pval) { # Additional valules?
			if ($pval) {
				$vars1.="<param name=\"$pkey\" value=\"$pval\" />\n"; # Once as <param ...> tags
				$vars2.=" $pkey=\"$pval\""; # And once more as values for the <embed ... /> tag
			}
		}

		$embednum++; # Next embedding

		# And here we go: Create the entire object/embed tag to actually embed it
		$result=<<<EOT

<object id="gzflashembed_$embednum" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=$version" height="$height" width="$width" title="$title" align="$align">
<param name="Movie" value="$fullpath" />
$vars1<embed id="gzflashembed_E" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer/" src="$fullpath" height="$height" width="$width" alt="$title" title="$title" align="$align"$vars2 />
</object>

EOT;

		# Now let's care for the swf's text content - in case it's store locally
		if ($fullabspath) {
			$result.=botgzflashembed_invisibletext($fullabspath); # Get the text and embed it as HTML comment
		}

	}

	return $result; # And out we are

}

# ---------------------------------------------------------------------------------

# === tries to retrieve the invisible text within the SWF file through swf2html
function botgzflashembed_invisibletext($fullabspath) {
global $textembed,$swftextcss;

	$result=""; # Sanity - no result (pessimistic)

	if (file_exists($fullabspath)) { # Does this SWF file exist at all?

		$islin=file_exists(JPATH_SITE."/swf2html"); # Linux executable?
		$iswin=file_exists(JPATH_SITE."/swf2html.exe"); # Windows executable?

		if ($iswin xor $islin) { # Just one? But not both ... Please!!

			$gzfedb="#__gzflashembed"; # This will be the name for our text cache

			# Check if our text cache exists - or otherwise create it
			$dbexists = botgzflashembed_checkorcreatedb($gzfedb);

			if ($dbexists) { # text cache exists?

				$timestamp=filemtime($fullabspath); # When was the last change to this SWF?

				# Crop the SWF filename by the mosConfig_absolute_path for the DB
				$swffilename=substr($fullabspath,strlen(JPATH_SITE)+1); # Strip first slash as well

				# Let's check: Do we already have the invisible text for this SWF file at its current change date?
				$db		=& JFactory::getDBO();
				$sql="SELECT swftext FROM $gzfedb where timestamp=$timestamp and swffilename='$swffilename'";
				$db->setQuery($sql);
				$rows = $db->loadObjectList( 'id' );

				$rows = false;

				if ($rows) { # We have a result?

					$swftext=stripslashes($rows[""]->swftext); # And this is it! Nothing else to do!
					# ... And it's truly just one row, as timestamp/fullabspath together is unique

				} else { # No, no database result -- let's get it from the file

					$swf2html=JPATH_SITE."/swf2html".($iswin ? ".exe" : ""); # Which executable?
					$shellcall=$swf2html." ".$fullabspath; # This is the command wie have to call ...
					$swftext=@shell_exec($shellcall); # ... though this would be impossible if SafeMode = on

					if ($swftext) { # Got a result? (Not if we're in safe_mode)

						$swftext=utf8_decode($swftext); # Necessary for Flash 6+

				    $swftext=str_replace(chr(13),"",$swftext); # remove CRs - in case they exist
				    $swftext=str_replace(chr(10),"",$swftext); # remove LFs - in case they exist
				    $swftext=str_replace(">","> ",$swftext); # Place a blank after each tag
				    $swftext=str_replace("<"," <",$swftext); # Place a blank before each tag
						$swftext=strip_tags($swftext); # Remove HTML tags - leave just verbose text
						while (strpos($swftext,"  ")!==false) {
					    $swftext=str_replace("  "," ",$swftext); # Force double blanks into single ones
						}
						$swftext=trim($swftext); # Crop beginning and end

						$swftext=htmlentities(html_entity_decode($swftext)); # Seems to be helpful

						# Now we've got this, let's store this in the cache for easier later retrieval

						# First: Remove any previous version(s) of this SWF file we may have in the cache
						$sql="DELETE FROM $gzfedb where swffilename='$swffilename'";
						$db->setQuery($sql); $db->query();

						# And now store the latest version
						$dbswftext=addslashes($swftext); # Escape special characters
						$sql="INSERT INTO $gzfedb VALUES ('$swffilename',$timestamp,'$dbswftext')";
						$db->setQuery($sql); $db->query();

					} # if ($swftext)
				} # else if ($rows)

				if ($swftext) { # Did we get the text from the DB or straight from the file?

					$result=""; # Sanity;

					if ( ($textembed==0) or ($textembed==2) ) { # HTML comment ... or both
						$result.="<!-- $swftext -->\n";
					}

					if ( ($textembed==1) or ($textembed==2) ) { # Invisible DIV text ... or both

						$formatting=( $swftextcss ? "class=\"$swftextcss\"" : "style=\"display:none\"" );

						$result.="<div $formatting>$swftext</div>\n";
					}

					if ($textembed==3) { # <noembed>...</noembed>

						$result.="<noembed><p>$swftext</p></noembed>\n";

					}

				}

			} # if ($dbexists)
		} # if ($iswin xor $islin)
	} # if (file_exists($fullabspath))

	return $result;

}

# ---------------------------------------------------------------------------------

# === checks the existens of the text cache table or (if not) properly creates it
function botgzflashembed_checkorcreatedb($tblnam) {

	$db		=& JFactory::getDBO();
	$chksql="SELECT count(*) FROM $tblnam"; # Even this count would fail if it doesn't exist
	$db->setQuery($chksql);
	$dbexists = $db->query(); # False, if error encountered ie. table doesn't exists
	
	if (!$dbexists) { # Doesn't exist?
	
		# OK - then let's create it!
		$sql="CREATE TABLE $tblnam (". # Create our text cache table
					" swffilename varchar(255) PRIMARY KEY NOT NULL,". # SWF file name and path - unique
					" timestamp INTEGER NOT NULL,". # last change of that SWF file
					" swftext MEDIUMTEXT NOT NULL,". # invisible text within SWF file
					" unique (timestamp,swffilename)". # lastchange of filename together should be unique
					")";

		$db->setQuery($sql);
		$db->query();
	
		$db->setQuery($chksql); # Once more: Check if the table exists
		$dbexists = $db->query(); # False, if error encountered ie. table doesn't exists
	}

	return $dbexists;
}

# ---------------------------------------------------------------------------------

?>

